<?php
/**
 * @version $Id: groupjive.html.php
 * @package Joomla!
 * @subpackage GroupJive
 * @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
 * @Joomla! is Free Software
 * @author Joshua Holmes
 * @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
 */

if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }
global $_CB_framework;

if ( ! defined( 'GJBASEPATH' ) ) {
	define( 'GJBASEPATH', dirname( __FILE__ ) );
}

if ( ! defined( 'JPATH' ) ) {
	define( 'JPATH', $_CB_framework->getCfg( 'absolute_path' ) );
}

if ( file_exists( JPATH . '/includes/HTML_toolbar.php' ) ) {
	require_once ( JPATH . '/includes/HTML_toolbar.php' );
}

class HTML_wg {

	function &createTemplate( $template = null ) {
		global $option, $gjConfig;
		
		if ( file_exists( GJBASEPATH . '/patTemplate.php' ) ) {
			require_once ( GJBASEPATH . '/patTemplate.php' );
		}
		
		$tmpl										=&	gjPatFactory::createTemplate( $option, true, false );
		
		if ( file_exists( GJBASEPATH . '/templates/' . $gjConfig['template'] . '/' . $template ) ) {
			$tmpl->setRoot( GJBASEPATH . '/templates/' . $gjConfig['template'] );
		} else {
			$tmpl->setRoot( GJBASEPATH . '/templates/default' );
		}
		
		$tmpl->readTemplatesFromInput( $template );
		
		return $tmpl;
	}

	function newgroup( $rows, $gj_groupname = null, $gj_aboutgroup = null, $message = null ) {
		global $_CB_framework, $Itemid, $_GJ_TEMPLATES;
		
		$tmpl										=&	HTML_wg::createTemplate( 'script.tmpl' );
		$typeCat									=	null;
		$options_cat								=	null;
		$options_type								=	null;
		
		foreach ( $rows as $val ) {
			$typeCat								.=	"typeCat[" . $val->id . "] = new Array();\n"
													.	"typeCat[" . $val->id . "][0]=" . $val->create_open . ";\n"
													.	"typeCat[" . $val->id . "][1]=" . $val->create_closed . ";\n"
													.	"typeCat[" . $val->id . "][2]=" . $val->create_invite . ";\n";
		}
		
		$tmpl->addVar( 'javascript', 'GJ_TYPECAT', $typeCat );
		
		$_CB_framework->document->addHeadCustomHtml( $tmpl->getParsedTemplate( 'javascript' ) );
		
		$tmpl										=&	HTML_wg::createTemplate( 'newgroup.tmpl' );
		
		$tmpl->addVar( 'newgroup', 'GJ_MESSAGE', $message );
		$tmpl->addVar( 'newgroup', 'GJ_GROUPNAME', $gj_groupname );
		$tmpl->addVar( 'newgroup', 'GJ_DESCR', $gj_aboutgroup );
		
		if ( ! isset( $_POST['category'] ) ) {
			$_POST['category']						=	$rows[0]->id;
		}
		
		if ( ! isset( $_POST['type'] ) ) {
			$_POST['type']							=	'0';
		}
		
		foreach ( $rows as $row ) {
			$selected								=	null;
			
			if ( $_POST['category'] == $row->id ) {
				$selected							=	'selected="selected"';
			}
			
			$options_cat							.=	'<option ' . $selected . ' value="' . $row->id . '">' . $row->catname . '</option>';
		}
		
		$tmpl->addVar( 'newgroup', 'GJ_OPTIONS_CAT', $options_cat );
		
		$ind										=	0;
		$desc										=	array ( GJ_OPEN, GJ_APREQUIRED, GJ_PRIVATE );
		$field										=	array ( 'create_open', 'create_closed', 'create_invite' );
		
		foreach ( $rows as $key => $row ) {
			if ( $row->id == $_POST['category'] ) {
				$ind								=	$key;
				break;
			}
		}
		
		for ( $i = 0; $i < 3; $i ++ ) {
			$f										=	$field[$i];
			$o										=	$rows[$ind];
			if ( $o->$f ) {
				$selected							=	null;
				
				if ( $_POST['type'] == ( $i + 1 ) ) {
					$selected						=	'selected="selected"';
				}
				
				$options_type						.=	'<option ' . $selected . ' value="' . ( $i + 1 ) . '">' . $desc[$i] . '</option>';
			}
		}
		
		$_CB_framework->appendPathWay( GJ_CREATEGROUP_PATH );
		
		$tmpl->addVar( 'newgroup', 'GJ_OPTIONS_TYPE', $options_type );
		$tmpl->addVar( 'newgroup', 'GJ_HIDDEN_I', $row->id );
		$tmpl->addVar( 'newgroup', 'ITEMID', $Itemid );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'newgroup' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_GROUP_NEW, cbSef( 'index.php?option=com_groupjive&action=gj.core.groups.createnewgroup&Itemid=' . $Itemid ) );
	}

	function groupcreated( $NeedApproval ) {
		global $_GJ_TEMPLATES;
		
		$tmpl										=&	HTML_wg::createTemplate( 'groupcreated.tmpl' );
		
		if ( $NeedApproval == 1 ) {
			$tmpl->addVar( 'groupcreated', 'GJ_NEEDAPPROVAL', 'yes' );
		} else {
			$tmpl->addVar( 'groupcreated', 'GJ_NEEDAPPROVAL', 'no' );
		}
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'groupcreated' ), 'center' );
	}

	function showmenu() {
		global $Itemid, $_GJ_TEMPLATES, $gjConfig, $_CB_framework;
		
		$allowcreategroups							=	( $gjConfig['create_groups'] && ( $_CB_framework->myCmsGid() != 0 ) );
		$link										=	null;
		$tmpl										=&	HTML_wg::createTemplate( 'showmenu.tmpl' );
		
		if ( $allowcreategroups != false ) {
			$link									=	'<p><a href="' . cbSef( 'index.php?option=com_groupjive&action=gj.core.groups.createnewgroup&Itemid=' . $Itemid ) . '">' . GJ_CREATEGROUP . '</a></p>';
			
			$tmpl->addVar( 'showmenu', 'CREATEGROUPSLINK', $link );
		} else {
			$tmpl->addVar( 'showmenu', 'CREATEGROUPSLINK', $link );
		}
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'showmenu' ), 'top' );
	}

	function errorpage( $message, $intro = null, $gid = 0, $type = 'error' ) {
		global $_CB_database, $_CB_framework, $_GJ_TEMPLATES;
		
		$g											=	new groupJiveGroup( $_CB_database );
		$g->getArray( $gid );
		
		if ( $_CB_framework->myId() == 0 ) {
			$type									=	null;
			$showemail								=	0;
		} else {
			$showemail								=	1;
		}
		
		$tmpl										=&	HTML_wg::createTemplate( 'error.tmpl' );
		
		$tmpl->addVar( 'errorpage', 'GJ_ERROR_INTROMESSAGE', $intro );
		$tmpl->addVar( 'errorpage', 'GJ_MESSAGE_TYPE', $type );
		$tmpl->addVar( 'errorpage', 'GJ_ERROR_MESSAGE', $message );
		$tmpl->addVar( 'errorpage', 'GJ_SHOWEMAIL', $showemail );
		$tmpl->addRows( 'errorpage', $g->asArray );
		$tmpl->addVar( 'errorpage', 'GJ_ERROR_LINK', HTML_wg::backButton() );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'errorpage' ), 'center' );
	}

	function member_list( $gid, $count, $usrows, $pageNav ) {
		global $Itemid, $_CB_framework, $_CB_database, $admin, $gjConfig, $_GJ_TEMPLATES;
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $gid, 'mini' );
		
		$tmplrowdata								=	array ();
		
		for ( $i = 0; $i < count( $usrows ); $i ++ ) {
			$ur										=&	$usrows[$i];
			
			$cbUser									=&	CBuser::getInstance( $ur->id_user );
			
			if ( ! $cbUser ) {
				$cbUser								=&	CBuser::getInstance( null );
			}
			
			$tmplrow['IMAGE']						=	$cbUser->getField( 'avatar', null, 'csv', 'none', 'list' );
			$tmplrow['ID_USER']						=	$ur->id_user;
			
			if ( $gjConfig['real_names'] ) {
				$tmplrow['USERNAME']				=	$ur->name;
			} else {
				$tmplrow['USERNAME']				=	$ur->username;
			}
			
			$tmplrow['ID_GROUP']					=	$gid;
			$tmplrow['DATE']						=	$ur->date;
			
			if ( ( ismoder( $gid, $_CB_framework->myId() ) || $admin ) && $ur->id_user != $ur->creator ) {
				$tmplrow['ISMODER']					=	'yes';
			} else {
				$tmplrow['ISMODER']					=	'no';
			}
			
			$query									=	'SELECT COUNT(*)'
													.	"\n FROM "	. $_CB_database->NameQuote( '#__session' )
													.	"\n WHERE "	. $_CB_database->NameQuote( 'userid' ) . " = " . (int) $ur->id_user;
			$_CB_database->setQuery( $query );
			$isonline								=	$_CB_database->loadResult();
			
			$tmplrow['ISONLINE']					=	$isonline;
			
			if ( $isonline > 0 ) {
				$tmplrow['ONLINESTATUS']			=	GJ_USERONLINE;
			} else {
				$tmplrow['ONLINESTATUS']			=	GJ_USEROFFLINE;
			}
			
			array_push( $tmplrowdata, $tmplrow );
		}
		
		$tmpl										=&	HTML_wg::createTemplate( 'member_list.tmpl' );
		
		$tmpl->addVar( 'member_list', 'GJ_COUNT', $count );
		$tmpl->addVar( 'member_list', 'ITEMID', $Itemid );
		$tmpl->addVar( 'member_list', 'ACTION', 'gj.core.members.showmemberlist' );
		$tmpl->addVar( 'member_list', 'GROUPID', $gid );
		$tmpl->addRows( 'list_members', $tmplrowdata );
		
		outputCbJs( 1 );
		setTemplateVars( $tmpl, $pageNav, 'member_list' );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'member_list' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_MEMBERS_GROUP, cbSef( 'index.php?option=com_groupjive&action=gj.core.members.showmemberlist&groupid=' . $gid . '&Itemid=' . $Itemid ) );
	}

	function bulletin( $gid, $blogrows ) {
		global $_CB_framework, $Itemid, $gjConfig, $_GJ_TEMPLATES;
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $gid );
		
		$tmpl										=&	HTML_wg::createTemplate( 'bulletin.tmpl' );
		$tmplrowdata								=	array ();
		
		if ( ! count( $blogrows ) ) {
			$tmpl->addVar( 'bulletin', 'GJ_SHOWMESSAGES', 'no' );
		} else {
			$tmpl->addVar( 'bulletin', 'GJ_SHOWMESSAGES', 'yes' );
			
			for ( $j = 0; $j < count( $blogrows ); $j ++ ) {
				$tmplrow							=	get_object_vars( $blogrows[$j] );
				
				array_push( $tmplrowdata, $tmplrow );
			}
		}
		
		if ( ( ! $gjConfig['bul_creator'] && checkuseractive( $gid, $_CB_framework->myId() ) ) || ismoder( $gid, $_CB_framework->myId() ) ) {
			$tmpl->addVar( 'bulletin', 'GJ_SHOWFORM', 'yes' );
			
			if ( $gjConfig['wysiwyg'] ) {
				$inputbox							=	$_CB_framework->displayCmsEditor( 'message', null, $gjConfig['wysiwyg_width'], $gjConfig['wysiwyg_height'], $gjConfig['wysiwyg_cols'], $gjConfig['wysiwyg_rows'] );
				$note								=	null;
			} else {
				$inputbox							=	'<textarea name="message" cols="40" rows="8" class="inputbox"></textarea><br/>';
				$note								=	'* ' . GJ_HTML_NOT_ALLOW;
			}
		} else {
			$tmpl->addVar( 'bulletin', 'GJ_SHOWFORM', 'no' );
		}
		
		$tmpl->addVar( 'bulletin', 'GJ_ID_GROUP', $gid );
		$tmpl->addVar( 'bulletin', 'GJ_NOTE', ( isset( $note ) ? $note : null ) );
		$tmpl->addVar( 'bulletin', 'ITEMID', $Itemid );
		$tmpl->addVar( 'bulletin', 'GJ_INPUTBOX', ( isset( $inputbox ) ? $inputbox : null ) );
		$tmpl->addRows( 'list_messages', $tmplrowdata );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'bulletin' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_BULLETIN_GROUP, cbSef( 'index.php?option=com_groupjive&action=gj.core.bulletin.showbulletin&groupid=' . $gid . '&Itemid=' . $Itemid ) );
	}

	function showfullmessage( &$data ) {
		global $_CB_framework, $Itemid, $admin, $_GJ_TEMPLATES;
		
		$d											=&	$data[0];
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $d->group_id );
		
		$tmpl										=&	HTML_wg::createTemplate( 'showfullmessage.tmpl' );
		$d->author_name								=	$d->username;
		
		$tmpl->addObject( 'showfullmessage', $d );
		$tmpl->addVar( 'showfullmessage', 'GJ_IS_OWNER', ( $_CB_framework->myId() == $d->author_id || $admin || ismoder( $d->group_id, $_CB_framework->myId() ) ) ? 'yes' : 'no' );
		$tmpl->addVar( 'showfullmessage', 'ITEMID', $Itemid );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'showfullmessage' ), 'center' );
		$_CB_framework->appendPathWay( $d->subject, cbSef( 'index.php?option=com_groupjive&action=gj.core.bulletin.showfullmessage&idm=' . $d->id . '&groupid=' . $d->group_id . '&Itemid=' . $Itemid ) );
	}

	function inactive( &$rows, $group ) {
		global $_CB_framework, $Itemid, $_GJ_TEMPLATES;
		
		if ( count( $rows ) == 0 ) {
			HTML_wg::errorpage( GJ_NOT_INACTIVE, null, $group, 'error' );
		} else {
			$tmpl									=&	HTML_wg::createTemplate( 'inactive.tmpl' );
			
			$tmpl->addRows( 'list_inactive', $rows );
			$tmpl->addVar( 'list_inactive', 'ITEMID', $Itemid );
			
			$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'inactive' ), 'center' );
		}
		
		$_CB_framework->appendPathWay( GJ_PATH_MEMBERS_INACTIVE, cbSef( 'index.php?option=com_groupjive&action=gj.core.members.showinactiveusers&groupid=' . $group . '&Itemid=' . $Itemid ) );
	}

	function transfer( $groupid ) {
		global $_CB_framework, $Itemid, $gjConfig, $admin, $_GJ_TEMPLATES;
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $groupid );
		
		if ( ! checkuser( $groupid, $_CB_framework->myId() ) && ! $admin ) {
			HTML_wg::errorpage( GJ_ONLY_CURRENT, null, $groupid, 'error' );
			return;
		}
		
		$tmpl										=&	HTML_wg::createTemplate( 'transfer.tmpl' );
		
		$tmpl->addVar( 'transfer', 'ID', $groupid );
		$tmpl->addVar( 'transfer', 'ITEMID', $Itemid );
		
		if ( $gjConfig['ajax_active'] && ( $_CB_framework->myCmsGid() >= $gjConfig['ajax_access'] ) ) {
			$_CB_framework->document->addHeadScriptUrl( $_CB_framework->getCfg( 'live_site' ) . '/components/com_groupjive/js/ajax.js' );
			
			$html									=	'<div id="gjsearchbox"><div id="gjclose" class="gjclose"><a href="javascript:toggleLayer(\'gjsearchbox\');">X</a></div><div id="gjinviteresults"></div></div>';
			
			$tmpl->addVar( 'transfer', 'AJAX_DIV', $html );
			
			$url									=	$_CB_framework->getCfg( 'live_site' ) . '/index2.php?option=com_groupjive&action=gj.core.ajax.getuserlist&groupid=' . $groupid . '&username=';
			
			$tmpl->addVar( 'transfer', 'AJAX_EVENT', 'onKeyUp="username= document.getElementById(\'fr_name\').value;if (username.length >2) {callAHAH(\'' . $url . '\' + encodeURI(username), \'gjinviteresults\', \'' . $gjConfig['ajax_message'] . '\', \'Error while fetching the content.\')}"' );
		}
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'transfer' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_GROUP_TRANSFER, cbSef( 'index.php?option=com_groupjive&action=gj.core.members.transfer&groupid=' . $groupid . '&Itemid=' . $Itemid ) );
	}

	function invite( $row, $friendname, $usersfound, $pageNav ) {
		global $_CB_framework, $Itemid, $gjConfig, $_GJ_TEMPLATES;
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $row->id );
		
		if ( ! checkuser( $row->id, $_CB_framework->myId() ) ) {
			HTML_wg::errorpage( GJ_ONLY_CURRENT );
			return;
		}
		
		$link										=	'index.php?option=com_groupjive&action=gj.core.groups.sign&groupid=' . $row->id . '&Itemid=' . $Itemid;
		
		if ( $friendname ) {
			$link									.=	'&friendname=' . $friendname;
		}
		
		$link										=	cbSef( $link );
		
		$tmpl										=&	HTML_wg::createTemplate( 'invite.tmpl' );
		
		$tmpl->addVar( 'invite', 'ID', $row->id );
		$tmpl->addVar( 'invite', 'NAME', $row->name );
		$tmpl->addVar( 'invite', 'FRIENDNAME', $friendname );
		$tmpl->addVar( 'invite', 'ITEMID', $Itemid );
		
		if ( count( $usersfound ) > 0 ) {
			$tmpl->addVar( 'invite', 'GJ_SHOWRESULTS', 1 );
		}
		
		$tmpl->addRows( 'list_searchfriends', $usersfound );
		
		if ( $pageNav ) {
			outputCbJs( 1 );
			setTemplateVars( $tmpl, $pageNav, 'invite' );
		}
		
		if ( $gjConfig['ajax_active'] && ( $_CB_framework->myCmsGid() >= $gjConfig['ajax_access'] ) ) {
			$_CB_framework->document->addHeadScriptUrl( $_CB_framework->getCfg( 'live_site' ) . '/components/com_groupjive/js/ajax.js' );
			
			$html									=	'<div id="gjsearchbox"><div id="gjclose" class="gjclose"><a href="javascript:toggleLayer(\'gjsearchbox\');">X</a></div><div id="gjinviteresults"></div></div>';
			
			$tmpl->addVar( 'invite', 'AJAX_DIV', $html );
			
			$url									=	$_CB_framework->getCfg( 'live_site' ) . '/index2.php?option=com_groupjive&action=gj.core.ajax.getuserlist&username=';
			
			$tmpl->addVar( 'invite', 'AJAX_EVENT', 'onKeyUp="username= document.getElementById(\'fr_name\').value;if (username.length >2) {callAHAH(\'' . $url . '\' + encodeURI(username), \'gjinviteresults\', \'' . $gjConfig['ajax_message'] . '\', \'Error while fetching the content.\')}"' );
		}
		
		if ( $gjConfig['nonreg'] ) {
			$tmpl->addVar( 'invite', 'EMAIL', GJ_FR_EMAIL . '<br/><input type="text" name="fr_email" size="50" maxlength="255" class="inputbox" /><br/>' );
		}
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'invite' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_MEMBERS_INVITE, cbSef( 'index.php?option=com_groupjive&action=gj.core.groups.sign&groupid=' . $row->id . '&Itemid=' . $Itemid ) );
	}

	function archive( &$rows, $count, $idg, $pageNav ) {
		global $_CB_framework, $Itemid, $admin, $_GJ_TEMPLATES;
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $idg );
		
		$tmplrowdata								=	array ();
		
		for ( $j = 0; $j < count( $rows ); $j ++ ) {
			$tmplrow								=	get_object_vars( $rows[$j] );
			$tmplrow['gj_group']					=	$idg;
			
			if ( ismoder( $idg, $_CB_framework->myId() ) || $admin ) {
				$tmplrow['GJ_IS_MODER']				=	'yes';
			} else {
				$tmplrow['GJ_IS_MODER']				=	'no';
			}
			
			array_push( $tmplrowdata, $tmplrow );
		}
		
		$tmpl										=&	HTML_wg::createTemplate( 'archive.tmpl' );
		
		outputCbJs( 1 );
		setTemplateVars( $tmpl, $pageNav, 'archive' );
		
		$tmpl->addVar( 'archive', 'GJ_GROUP', $idg );
		$tmpl->addVar( 'archive', 'ACTION', 'gj.core.bulletin.showarchive' );
		$tmpl->addVar( 'archive', 'ITEMID', $Itemid );
		$tmpl->addRows( 'list_archive', $tmplrowdata );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'archive' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_BULLETIN_ARCHIVE, cbSef( 'index.php?option=com_groupjive&action=gj.core.bulletin.showarchive&groupid=' . $idg . '&Itemid=' . $Itemid ) );
	}

	function editpost( $row ) {
		global $_CB_framework, $Itemid, $gjConfig, $_GJ_TEMPLATES;
		
		$group_id									=	(int) cbGetParam( $row, 'group_id' );
		
		if ( $gjConfig['wysiwyg'] ) {
			$post									=	cbGetParam( $row, 'post', null, _CB_ALLOWRAW );
		} else {
			$post									=	cbGetParam( $row, 'post' );
		}
		
		$subject									=	cbGetParam( $row, 'subject' );
		$id											=	intval( cbGetParam( $row, 'id' ) );
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $group_id );
		
		$tmpl										=&	HTML_wg::createTemplate( 'editpost.tmpl' );
		
		$inputboxsubject							=	'<input type="text" name="subject" size="50" maxlength="255" class="inputbox" value="' . $subject . '" />';
		
		if ( $gjConfig['wysiwyg'] ) {
			$inputbox								=	$_CB_framework->displayCmsEditor( 'message', $post, $gjConfig['wysiwyg_width'], $gjConfig['wysiwyg_height'], $gjConfig['wysiwyg_cols'], $gjConfig['wysiwyg_rows'] );
			$note									=	null;
		} else {
			$inputbox								=	'<textarea name="message" cols="40" rows="8" class="inputbox">' . $post . '</textarea><br/>';
			$note									=	'* ' . GJ_HTML_NOT_ALLOW;
		}
		
		$tmpl->addVar( 'editpost', 'ITEMID', $Itemid );
		$tmpl->addVar( 'editpost', 'GJ_GROUP', $group_id );
		$tmpl->addVar( 'editpost', 'GJ_ID', $id );
		$tmpl->addVar( 'editpost', 'GJ_NOTE', $note );
		$tmpl->addVar( 'editpost', 'GJ_INPUTBOX_SUBJECT', $inputboxsubject );
		$tmpl->addVar( 'editpost', 'GJ_INPUTBOX', $inputbox );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'editpost' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_BULLETIN_EDIT, cbSef( 'index.php?option=com_groupjive&action=gj.core.bulletin.editpost&postid=' . $row . '&groupid=' . $group_id . '&Itemid=' . $Itemid ) );
	}

	function editgroup( $rows ) {
		global $_CB_framework, $Itemid, $_GJ_TEMPLATES;
		
		$row										=&	$rows[0];
		$option										=	null;
		
		require_once ( GJBASEPATH . '/gj/core/groups.php' );
		
		groups_controller::showgroup( $row->id, 'mini' );
		
		if ( $row->create_open ) {
			$option									.=	'<OPTION value="1"';
			
			if ( $row->type == '1' ) { 
				$option								.=	' selected="selected"';
			}
			
			$option									.=	'> ' . GJ_OPEN . ' </option>';
		}
		
		if ( $row->create_closed ) {
			$option									.=	'<OPTION value="2"';
			
			if ( $row->type == '2' ) {
				$option								.=	' selected="selected"';
			}
			
			$option									.=	'> ' . GJ_APREQUIRED . ' </option>';
		}
		
		if ( $row->create_invite ) {
			$option									.=	'<OPTION value="3"';
			
			if ( $row->type == '3' ) {
				$option								.=	' selected="selected"';
			}
			
			$option									.=	'> ' . GJ_PRIVATE . ' </option>';
		}
		
		$tmpl										=&	HTML_wg::createTemplate( 'editgroup.tmpl' );
		
		$tmpl->addVar( 'editgroup', 'GJ_OPTIONS', $option );
		$tmpl->addVar( 'editgroup', 'GJ_ID', $row->id );
		$tmpl->addVar( 'editgroup', 'GJ_GROUPNAME', $row->name );
		$tmpl->addVar( 'editgroup', 'GJ_GROUPDESCR', $row->descr );
		$tmpl->addVar( 'editgroup', 'ITEMID', $Itemid );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'editgroup' ), 'center' );
		$_CB_framework->appendPathWay( GJ_PATH_GROUP_EDIT, cbSef( 'index.php?option=com_groupjive&action=gj.core.groups.editgroup&groupid=' . $row->id . '&Itemid=' . $Itemid ) );
	}

	function showGroup( $row, $newusers, $logo, $image, $actions, $moderator_func, $size ) {
		global $_CB_framework, $Itemid, $gjConfig, $_GJ_TEMPLATES;
		
		$t											=	'showgroup' . $size;
		$tmpl										=&	HTML_wg::createTemplate( $t . '.tmpl' );
		
		$tmpl->addVar( $t, 'GJ_GROUPNAME', $row->groupname );
		$tmpl->addVar( $t, 'GJ_NEWUSERS', $newusers );
		$tmpl->addVar( $t, 'GJ_GROUPINFO', group_info( $row ) );
		$tmpl->addVar( $t, 'GJ_LINKS', links( $row ) );
		$tmpl->addVar( $t, 'GJ_GROUPLOGO', $logo );
		
		if ( $gjConfig['real_names'] ) {
			$tmpl->addVar( $t, 'GJ_GROUPCREATOR', $row->name );
		} else {
			$tmpl->addVar( $t, 'GJ_GROUPCREATOR', $row->username );
		}
		
		$tmpl->addVar( $t, 'GJ_GROUPID', $row->id );
		$tmpl->addVar( $t, 'ITEMID', $Itemid );
		$tmpl->addVar( $t, 'GJ_GROUPCREATORID', $row->user_id );
		$tmpl->addVar( $t, 'GJ_CREATORIMAGE', $image );
		$tmpl->addVar( $t, 'GJ_ACTIONS', $actions );
		
		if ( $_CB_framework->myId() ) {
			$tmpl->addVar( $t, 'SHOWMAILLINK', '1' );
		}
		
		$tmpl->addVar( $t, 'GJ_MODERATOR_FUNC', $moderator_func );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( $t ), 'center' );
		$_CB_framework->appendPathWay( $row->groupname, cbSef( 'index.php?option=com_groupjive&action=gj.core.groups.showgroup&groupid=' . $row->id . '&Itemid=' . $Itemid ) );
	}

	function showOverview( $rows ) {
		global $Itemid, $_GJ_TEMPLATES;
		
		$tmpl										=&	HTML_wg::createTemplate( 'showoverview.tmpl' );
		
		for ( $j = 0; $j < count( $rows ); $j ++ ) {
			$row									=&	$rows[$j];
			
			if ( ( file_exists( 'images/com_groupjive/' . $row['cat_image'] ) && ( $row['cat_image'] != null ) ) ) {
				$im									=	'images/com_groupjive/tn' . $row['cat_image'];
			} else {
				$im									=	'images/com_groupjive/groupjive_mini.png';
			}
			
			$row['CAT_IMAGE']						=	'<img src="' . $im . '" alt="' . $row['catname'] . '" style="vertical-align:middle;"/>';
		}
		
		$tmpl->addVar( 'list_overview', 'ITEMID', $Itemid );
		$tmpl->addRows( 'list_overview', $rows );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'showoverview' ), 'center' );
	}

	function showcat( &$rows, $id, $pageNav, $searchstring = null ) { 
		global $_CB_framework, $Itemid, $gjConfig, $admin, $_GJ_TEMPLATES, $_CB_database; // bkm added $_CB_database

/* bkm modifications for ONE-GROUP-ONLY. except all users can be in id_group #1 */
$query = "SELECT  id_group FROM `jos_gj_users` WHERE id_user = ".$_CB_framework->myId()." AND id_group <> '1' ";
$_CB_database->setQuery( $query ); $alreadyinagroup = $_CB_database->loadObjectList();

		for ( $i = 0; $i < count( $rows ); $i ++ ) {
			$row									=&	$rows[$i];
			$showgrouplink							=	cbSef( 'index.php?option=com_groupjive&action=gj.core.groups.showgroup&groupid=' . $row['id'] . '&Itemid=' . $Itemid );
			
			if ( file_exists( 'images/com_groupjive/' . $row['logo'] ) && ( $row['logo'] ) ) {
				$row['GJ_CATIMAGE']					=	cbSef( 'images/com_groupjive/tn' . $row['logo'] );
			} else if ( isset( $gjConfig['nophoto_logo'] ) && file_exists( 'images/com_groupjive/tn' . $gjConfig['nophoto_logo'] ) ) {
				$row['GJ_CATIMAGE']					=	cbSef( 'images/com_groupjive/tn' . $gjConfig['nophoto_logo'] );
			} else {
				$row['GJ_CATIMAGE']					=	cbSef( 'images/com_groupjive/groupjive_mini.png' );
			}
			
			$row['GJ_CATNAME']						=	$row['category_name'];
			$row['GJ_CATDESCRIPTION']				=	$row['category_description'];
			$row['GJ_URL_SHOWGROUP']				=	$showgrouplink;
			$row['GJ_LINKNAME_SHOWGROUP']			=	$row['name'];
			$row['GJ_SHOWURL_SHOWGROUP']			=	'yes';

// bkm default to no if user is a member of any group except #1
if ($alreadyinagroup){$row['GJ_SHOWURL_SHOWGROUP'] = 'no';} 
			
			if ( ( $row['type'] == 3 ) && ( checkuseractive( $row['id'], $_CB_framework->myId() ) ) ) {
				if ( $row['user_id'] == $_CB_framework->myId() ) {
					$row['GJ_PRIVACY_STATUS']		=	GJ_YOU_ARE_ADMIN;
				} else {
					$row['GJ_PRIVACY_STATUS']		=	GJ_ALREADY_MEMBER;
				}
			} elseif ( ( $row['type'] == '3' ) && ( ! checkuseractive( $row['id'], $_CB_framework->myId() ) ) ) {
				$row['GJ_SHOWURL_SHOWGROUP']		=	'no';
				$row['GJ_PRIVACY_STATUS']			=	GJ_INVITE_ONLY;
			} elseif ( ( $row['type'] != 3 ) && ( ! checkuser( $row['id'], $_CB_framework->myId() ) ) ) {
				if ( $_CB_framework->myCmsGid() != 0 AND !$alreadyinagroup) { /* bkm added !$alreadyinagroup qualifier */
					$row['GJ_PRIVACY_STATUS']		=	'<a href="' . cbSef( 'index.php?option=com_groupjive&action=gj.core.groups.sign&groupid=' . $row['id'] . '&Itemid=' . $Itemid ) . '">' . GJ_SIGN . '</a>';
				} else {
					$row['GJ_PRIVACY_STATUS']		=	'&nbsp;';
				}
			} elseif ( ( $row['type'] == 2 ) && ( ! checkuseractive( $row['id'], $_CB_framework->myId() ) ) ) { 
				$row['GJ_SHOWURL_SHOWGROUP']		=	'no';  
				$row['GJ_PRIVACY_STATUS']			=	GJ_PENDING;  
			} else {
				if ( $row['user_id'] == $_CB_framework->myId() ) {
					$row['GJ_PRIVACY_STATUS']		=	GJ_YOU_ARE_ADMIN;
					$row['GJ_SHOWURL_SHOWGROUP']	=	'yes'; /* bkm ADMINs override ONE-GROUP-ONLY policy*/
				} else {
					$row['GJ_PRIVACY_STATUS']		=	GJ_ALREADY_MEMBER;
					$row['GJ_SHOWURL_SHOWGROUP']	=	'yes'; /* bkm ALREADY_MEMBER override ONE-GROUP-ONLY policy*/
				}
			}
			
			if ( $admin ) {
				$row['GJ_SHOWURL_SHOWGROUP']		=	'yes';
			}
			
			$row['GROUPUSERCOUNT']					=	$row['groupusercount'];
			$row['GJ_CREATED_DATE']					=	$row['date_s'];
			$row['GJ_DESCRIPTION']					=	$row['group_description'];
		}
		
		$tmpl										=&	HTML_wg::createTemplate( 'showcat.tmpl' );
		
		if ( $searchstring ) {
			$tmpl->addVar( 'showcat', 'SEARCHSTRING', $searchstring );
			$tmpl->addVar( 'showcat', 'ACTION', 'gj.core.search.searchgroup' );
		} else {
			$tmpl->addVar( 'showcat', 'ACTION', 'gj.core.categories.showcategory' );
		}
		
		if ( $pageNav ) {
			outputCbJs( 1 );
			setTemplateVars( $tmpl, $pageNav, 'showcat' );
		}
		
		$tmpl->addVar( 'showcat', 'CATEGORYID', $id );
		
		if ( $_CB_framework->myId() ) {
			$tmpl->addVar( 'list_entry', 'SHOWMAILLINK', '1' );
		}
		
		$tmpl->addRows( 'list_entry', $rows );
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'showcat' ), 'center' );
		$_CB_framework->appendPathWay( $row['GJ_CATNAME'], cbSef( 'index.php?option=com_groupjive&action=gj.core.categories.showcategory&catid=' . $id . '&Itemid=' . $Itemid ) );
	}

	function showMailForm( $type, $gid, $subject, $body, $copy, $message, $showgroup = true ) {
		global $_CB_framework, $Itemid, $_GJ_TEMPLATES;
		
		if ( $showgroup == true ) {
			require_once ( GJBASEPATH . '/gj/core/groups.php' );
			
			groups_controller::showgroup( $gid );
		}
		
		$tmpl = & HTML_wg::createTemplate( 'showmailform.tmpl' );
		
		if ( $type == 'mailgroup' ) {
			$tmpl->addVar( 'showmailform', 'TASK', 'mailgroup' );
			$tmpl->addVar( 'showmailform', 'HEADER', GJ_MAIL_GROUP );
		} else {
			$tmpl->addVar( 'showmailform', 'TASK', 'mailgroupowner' );
			$tmpl->addVar( 'showmailform', 'HEADER', GJ_MAIL_OWNER );
		}
		
		$tmpl->addVar( 'showmailform', 'GID', $gid );
		$tmpl->addVar( 'showmailform', 'ITEMID', $Itemid );
		$tmpl->addVar( 'showmailform', 'SUBJECT', $subject );
		$tmpl->addVar( 'showmailform', 'BODY', $body );
		$tmpl->addVar( 'showmailform', 'GJ_MESSAGE', $message );
		$tmpl->addVar( 'showmailform', 'COPY', $copy );
		$tmpl->addVar( 'showmailform', 'GJ_ERROR_LINK', '<a href="' . GJ_REFERER . '">' . GJ_BACK . '</a>' );
		
		$_GJ_TEMPLATES->addContent( $tmpl->getParsedTemplate( 'showmailform' ), 'center' );
		
		if ( $type == 'mailgroup' ) {
			$_CB_framework->appendPathWay( GJ_PATH_EMAIL_GROUP, cbSef( 'index.php?option=com_groupjive&action=gj.core.mail.mailgroupmembers&groupid=' . $gid . '&Itemid=' . $Itemid ) );
		} elseif ( $type == 'mailowner' ) {
			$_CB_framework->appendPathWay( GJ_PATH_EMAIL_OWNER, cbSef( 'index.php?option=com_groupjive&action=gj.core.mail.mailowner&groupid=' . $gid . '&Itemid=' . $Itemid ) );
		}
	}

	function backButton() {
		global $_GJ_TEMPLATES;
		
		$_GJ_TEMPLATES->addContent( '<div class="back_button"><a href="javascript:history.go(-1)">' . GJ_BACK . '</a></div>', 'topleft' );
	}
}
?>
